%{
/*********************************************************/
/* book.l						 */
/* Copyright : Norwegian Telecom Research, 1993		 */
/* Programming : Jon Stephenson von Tetzchner		 */
/* This file can be changed and modified as long as this */
/* header is kept intact. This code can not be included	 */
/* in a commercial product.				 */
/*********************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "book.h"

%}
MIFEND    	"# End".*"Book"
FILENAME	"<FileName".*">"
KILL      	("#"|">"|"<").*
SPACE     	[ \t]+  
MIFSTART  	"<Book".*">".*"#".*"\n"
%%
{MIFSTART}  		BookStart();
{MIFEND}    		BookEnd();
{FILENAME}		PrintFileName();
"\n"        		{/* */}
{KILL}      		{/* */}
{SPACE}     		{/* */}
%%

FILE *f;
FILE *exists;
char *BOOKFilename;
char *BOOKTitle;
char LastFileName[300];
char *Language;

void BookStart()
{
    char full_filename[300];
    BOOKFilename = getenv("BOOKFilename");
    BOOKTitle = getenv("BOOKTitle");
    Language = getenv("DOCUMENTLANGUAGE");

    fprintf(stdout, "book: Starting translation of file \"%s\"\n",
		    BOOKFilename);

/*   
    strcpy(full_filename, BOOKFilename);
    strcat(full_filename, ".html");

    f = fopen(full_filename, "w");
    if (!f)
	{
	    fprintf(stderr, "book: Could not open book file \"%s\"\n",
			    full_filename);
	    exit(-1);
	}
    fprintf(f, "\n<HTML>\n");
    fprintf(f, "<TITLE>%s</TITLE>\n", BOOKFilename);
    fprintf(f, "<H1>%s</H1>\n", BOOKFilename);
    fprintf(f, "<UL>\n");
*/

    LastFileName[0] = 0;
}


void BookEnd()
{
    /* fprintf(f, "</UL>\n");
    fprintf(f, "\n</HTML>\n"); 
    fclose(f);	*/	
    fprintf(stdout, "book: End of translation\n");
}


/****************************************************************************
  PrintFileName() :
        Input  : Uses yytext
	Output : Prints name of file
 ****************************************************************************/

void PrintFileName()
{
    int i = 0, j = 0;
    char filename[200];
    char basename[200];
    char mifname[200];
    char htmlfilename1[200];
    char call[200];
    static char *fmfiles[] = {"TOC.doc", "LOF.doc", "LOT.doc", "AIX.doc",
		       "AML.doc", "APL.doc", "IOM.doc", "IX.doc",
		       "LOM.doc", "LOP.doc", "SIX.doc",
                       ".toc", ".lof", ".lot", ".aix", ".aml",
                       ".apl", ".iom", ".ix", ".lom", ".lop", ".six"};
    int num_fmfiles = 22;
    int fmpos;
    char *ptr;
    
    while(yytext[i] && yytext[i] != 96)
	{
	    i++;
	}

    if (yytext[i] == 96)
	{
	    i++;
	    while (yytext[i] && yytext[i] != 39)
		{
		    if (yytext[i] == '<')			
			{
			    if (yytext[i+1] == 'c')
				{	
				    i++;		/* Get by <c\> */
				    i++;
				    i++;
				    i++;
				    while (yytext[i] && yytext[i] != '<' && yytext[i] != 39)
					{
					    filename[j++] = yytext[i++];
					}
				    
				    filename[j++] = 0;
				    for (fmpos = 0; fmpos < num_fmfiles; fmpos++)
					{
					    if (strstr(filename, fmfiles[fmpos])) return;
					}

				    strcpy(basename, filename);
				    sprintf(mifname, "%s.mif", basename);

				    exists = fopen(mifname, "r");
				    if (exists)
				        {
					    close(exists);
					}
				    else
				        {
					    if ((ptr = (char *) strstr(basename, ".doc")) != NULL)
						{
						    *ptr = 0;
						    sprintf(mifname, "%s.mif", basename);
						    exists = fopen(mifname, "r");
						    if (exists)
							{
							    close(exists);
							}
						    else
							{
							    fprintf(stderr,"book: MIF version of \"%s\" not found\n", filename);
							    return;
							}
						}
					    else
					        {
						    fprintf(stderr,"book: MIF version of \"%s\" not found\n", filename);
						    return;
						}
					}

				    sprintf(call, "rm -f %s.html", basename);
				    system(call);

/*				    sprintf(call, "fm2mif %s", filename);
				    system(call); */

				    sprintf(call, "f2htranslate %s %s.html2 %s.tmp.000I %s.tmp.000L %s",
						  basename, basename, BOOKFilename, BOOKFilename, BOOKTitle);
				    system(call);

				    if (LastFileName[0])
					{
					    FILE *lastfile, *thisfile;
					    lastfile = fopen(LastFileName, "a")
;
					    if (lastfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
						        {
							    fprintf(lastfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A> ", BOOKFilename);
							    fprintf(lastfile, " <A HREF=\"%s.html\"><IMG SRC=\"fm2html-next.gif\">Neste Kapittel</A> ", basename);
							}
						    else
						        {
							    fprintf(lastfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A> ", BOOKFilename);
							    fprintf(lastfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-next.gif\">Next Chapter</A> ", basename);
							}
						    fclose(lastfile);
						}

					    sprintf(htmlfilename1, "%s.html1", basename);
					    thisfile = fopen(htmlfilename1, "w");
					    if (thisfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
						         {
							     fprintf(thisfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A> ", BOOKFilename);
							     fprintf(thisfile, "<A HREF=\"%s\"><IMG SRC=\"fm2html-previous.gif\">Forrige Kapittel</A> ", LastFileName);	
/*							     fprintf(thisfile, "<A HREF=\"%s\"><IMG SRC=\"fm2html-next.gif\">Neste Kapittel</A> ", basename); */
							 }
						    else
						         {
							     fprintf(thisfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A> ", BOOKFilename);
							     fprintf(thisfile, "<A HREF=\"%s\"><IMG SRC=\"fm2html-previous.gif\">Previous Chapter</A> ", LastFileName);
/*							     fprintf(thisfile, "<A HREF=\"%s\"><IMG SRC=\"fm2html-next.xbm\">Next Chapter</A> ", basename); */
							 }
						    fclose(thisfile);

						    /* Add `Forrige` to head of file */
						    sprintf(call, "cat %s.html1 %s.html2 > %s.html",
							    basename, basename, basename);
						    system(call);

						    sprintf(call, "rm -f %s.html1 %s.html2",
							    basename,basename);
						    system(call);
						}
					    else
						{ 
						    fprintf(stderr, "book: Could not open file %s for writing\n", htmlfilename1);
						    exit(-1);
						}
					}
				    else
					{
					    FILE *thisfile;
					    sprintf(htmlfilename1, "%s.html1", basename);
					    thisfile = fopen(htmlfilename1, "w");
					    if (thisfile)
						{
						    if (Language && !strcasecmp(Language, "NO"))
						         {
							     fprintf(thisfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Innhold</A> ", BOOKFilename);
							 }
						    else
						         {
							     fprintf(thisfile, "<A HREF=\"%s.html\"><IMG SRC=\"fm2html-toc.gif\">Table of Contents</A> ", BOOKFilename);
							 }
						    fclose(thisfile);

						    /* Add `Forrige` to head of file */
						    sprintf(call, "cat %s.html1 %s.html2 > %s.html",
							    basename, basename, basename);
						    system(call);

						    sprintf(call, "rm -f %s.html1 %s.html2",
							    basename,basename);
						    system(call);
						}
					    else
						{ 
						    fprintf(stderr, "book: Could not open file %s for writing\n", htmlfilename1);
						    exit(-1);
						}
/*					    sprintf(call,"mv %s.html2 %s.html",
						    basename, basename);
					    system(call);*/
					}
				    sprintf(LastFileName, "%s.html", basename);

				}
			}
		    i++;
		}
	}
}


/*************************************************************************
int main () : added by popular demand to get rid of -lfl...
**************************************************************************/

int main( argc, argv )
      int argc;
      char *argv[];
{
    return yylex();
}


#ifndef yywrap		/* Added as it seems it has been moved to the flex */
int yywrap()		/* library on some systems */
{return 1;}
#endif
