#!-PERL-
# mif2gif.pl
# Copyright : Norwegian Telecom Research, 1993
# Programming : Jon Stephenson von Tetzchner
# This file can be changed and modified as long as this
# header is kept intact. This code can not be included
# in a commercial product.

# This script is part of the fm2html package.

$TMPNAME             = "mif2gif.fmbatch";
$PRINT_SETTINGS_NAME = "mif2gif.printsettings";
$| = 1;

$pid = $$;
$tmpdir = $ENV{'TMPDIR'};
if ( ! $tmpdir ) { $tmpdir = "-TMPDIR-"; }
if ( ! $tmpdir ) { $tmpdir = `pwd`; }
$tmpdir =~ s#/$##;
$tmpfile = "$tmpdir/$TMPNAME.$pid";


$xdpi = $ENV{'F2HXDPI'} || 72;
$ydpi = $ENV{'F2HYDPI'} || 72;

if ($ENV{'MIF2GIFPRINTSETTINGSFILE'})
  { $print_settings_file = $ENV{'MIF2GIFPRINTSETTINGSFILE'}; }
else
  {
      $tmpsettings = "$tmpdir/mif2gif.printsettings.tmp.$pid";
      system ("cp -LIBDIR-/$PRINT_SETTINGS_NAME $tmpsettings");
      $print_settings_file = "$tmpsettings"; 
  }

if ($#ARGV == -1)
{
  print "\nUseage: mif2gif mif-files\n";
  print "\n";
  print "\tThe parameters specify the names of files to translate.\n";
  die;
}

print "\nmif2gif: Translating graphics files from MIF to PostScript\n";
$numfiles = 0;

while (@ARGV)
{
  $miffiles[$numfiles] = shift;
  $numfiles +=1;
}

open(TMPF, ">$tmpfile") ||
  die "mif2gif: Could not open temporary fmbatch file \"$tmpfile\"... exiting";
-e $print_settings_file ||
  die "mif2gif: Could not find print settings file \"$print_settings_file\"... \
exiting";
print TMPF "Open $print_settings_file\n";
for ($i = 0; $i< $numfiles; $i++)
{
  print TMPF "Open $miffiles[$i] \n";
  print TMPF "Print $miffiles[$i] $print_settings_file\n";
  print TMPF "Quit $miffiles[$i] \n";
}
print TMPF "Quit $print_settings_file \n";
print TMPF "Quit\n";
close(TMPF);

system("-FMBATCH- $tmpfile");
system("rm -f $tmpfile $tmpsettings");

sleep 3;

print "\nmif2gif: Translating graphics files from PostScript to GIF\n";

for ($i = 0; $i< $numfiles; $i++)
{	
  $psfile = $miffiles[$i];
  system("rm $psfile");
  $psfile =~s/.mif/.ps/; 
  system("ps2gif -color -xdpi $xdpi -ydpi $ydpi -crop -borderwidth 7 $psfile");
  system("rm $psfile");
}
