#!-PERL-
# fm2mif.pl
# Copyright : Norwegian Telecom Research, 1993
# Programming : Jon Stephenson von Tetzchner
# This file can be changed and modified as long as this
# header is kept intact. This code can not be included
# in a commercial product.

# Based on pstorast & ps2bits by Kjell M. Myksvold.

# This script is part of the fm2html package.

$TMPNAME = "ps2gif";

$tmpdir = $ENV{'TMPDIR'};
if ( ! $tmpdir ) { $tmpdir = "-TMPDIR-"; }
if ( ! $tmpdir ) { $tmpdir = `pwd`; chop( $tmpdir ); }
$tmpdir =~ s#/$##;
$tmpfile = "$tmpdir/$TMPNAME.$$";

$color = 0;
$realcolor = 0;
$xdpi = 72;
$ydpi = 72;
$crop = "";
$borderwidth = 0;


if ($#ARGV == -1)
{
  print "\nUsage: ps2gif [-color] [-24] [-xdpi x] [-ydpi y] [-crop] [-border n] infile [outfile]\n";
  print "";
  die;
}

print "ps2gif:\n";

# *** Get command line parameters
while (@ARGV)
{
    $param = shift;
    if ($param =~ /-color/i)
	{
	    $color = 1;
	}
    elsif ($param =~ /-24/i)
	{
	    $realcolor = 1;
	}
    elsif ($param =~ /-xdpi/i)
	{
	    $xdpi = shift;
	}
    elsif ($param =~ /-ydpi/i)
	{
	    $ydpi = shift;
	}
    elsif ($param =~ /-crop/i)
	{
	    $crop = " | -PNMCROP- ";
	}
    elsif ($param =~ /-border/i)
	{
	    $borderwidth = shift;
	    $border = " | -PNMMARGIN- $borderwidth";
	}

    elsif ($param =~ /^-/)
	{
	    print "Unknown parameter \"$param\". Ignored.\n";
	}
    else
	{
            if (!$infile)
		{
		    $infile = $param;
		}
	    else
		{
		    $outfile = $param;
		}
	}
}

if (!$infile)
{
  print "\nUsage: ps2gif [-color] [-24]\n";
  print "";
  die;
}

if ($infile && !$outfile)
{
    $outfile = $infile;
    $outfile =~ s/\.ps//;
}

$outfile =~ s/\.gif//;
print "Input File: $infile\n";
print "Output File: $outfile.gif\n";
print "Xdpi: $xdpi\n";
print "Ydpi: $ydpi\n";
if ($realcolor) {print "24 bit color\n";}
elsif ($color) {print "8 bit color\n";}
else {print "Mono\n";}
if ($crop) {print "Crop picture\n";}
print "Border width : $borderwidth\n";

system ("cp $infile $tmpfile.ps");
$gsline = "| -GS- -dNODISPLAY " . "-r$xdpi" . "x" . "$ydpi " . "-PSTOPPM- 1>/dev/null";
open (GS, $gsline) || die "ps2gif: Could not start GhostScript (gs)\n";
print GS "$xdpi $ydpi ppmsetdensity";
if ($realcolor) {print GS "($tmpfile) ppm24run\n";}
elsif ($color)  {print GS "($tmpfile) ppm8run\n";}
else {print GS "($tmpfile) ppm1run\n";}
close (GS);

if (-e "$tmpfile.ppm")
{
    $ppmfile = "$tmpfile.ppm";
    $giffile = "$outfile.gif";
    system ("cat $ppmfile $crop $border | -PPMTOGIF- > $giffile");
    unlink ($ppmfile);
}
else
{
    $i = 1;
    $ppmfile = "$tmpfile.$i" . "ppm";
    $giffile = "$infile.$i" . ".gif";
    while (-e "$ppmfile")
	{
	    system ("cat $ppmfile $crop $border | -PPMTOGIF-  > $giffile");
	    unlink($ppmfile);
	    $i = $i + 1;
	    $ppmfile = "$tmpfile.$i" . "ppm";
	    $giffile = "$infile.$i" . ".gif";
	}
}

unlink ("$tmpfile.ps");
